
#include "stdafx.h"
#include "System.h"

//-----------------------------
//	[Jΐp
//-----------------------------
CRITICAL_SECTION cs;
GAMESTATEEX *GameState;

DWORD Send(HANDLE pipe, char *msg)
{
	DWORD NumberOfBytesWritten = 0;
	if(pipe != NULL){
		Sleep(10);
		WriteFile(pipe, msg, strlen( msg ) + 1, &NumberOfBytesWritten, NULL);
	}
	return NumberOfBytesWritten;
}

DWORD Recv(HANDLE pipe, char *msg, size_t numberOfElements)
{
	DWORD NumberOfBytesRead = 0;
	if(pipe != NULL){
		ReadFile(pipe, msg, numberOfElements, &NumberOfBytesRead, NULL);
		msg[NumberOfBytesRead] = NULL;
		DeleteNL(msg);
	}
	return NumberOfBytesRead;
}

DWORD WINAPI EngineReceiveThread(LPVOID pParam)
{
	char buffer[1024];
	PLAYERINFO *pPlayer = (PLAYERINFO *)pParam;

	while (ClientInfo.CDCD->LocalMatch != FALSE){
		if (Recv(pPlayer->ReadPipe, buffer, sizeof(buffer)) != 0){
			DoCommand(pPlayer, buffer);
		}
	}

	return TRUE;
}

PGAMESTATEEX CreateGameState()
{
	PGAMESTATEEX pGameState;
	pGameState = (PGAMESTATEEX)malloc(sizeof(GAMESTATEEX));

	pGameState->ShotNum = 0;
	pGameState->CurEnd = 0;
	pGameState->LastEnd = 0;
	pGameState->Random = 0.145f;
	memset(pGameState->Score, 0x00, sizeof(int)*10);
	pGameState->WhiteToMove = 0;
	memset(pGameState->body, 0x00, sizeof(float)*32);

	pGameState->Player = 0;
	pGameState->First.Color = 0;
	pGameState->Second.Color = 1;
	return pGameState;
}

DWORD WINAPI GameProgress(LPVOID pParam)
{
	DWORD dwThreadId;
	GameState = (PGAMESTATEEX)pParam;

	if(GameState->First.ReadPipe != NULL){
		CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE)EngineReceiveThread, &GameState->First, 0, &dwThreadId);
		Send(GameState->First.WritePipe, "ISREADY");
		GameState->First.Status = FALSE;
	}
	else{
		GameState->Player |= 1;
		GameState->First.Status = TRUE;
	}

	if(GameState->Second.ReadPipe != NULL){
		CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE)EngineReceiveThread, &GameState->Second, 0, &dwThreadId);
		Send(GameState->Second.WritePipe, "ISREADY");
		GameState->Second.Status = FALSE;
	}
	else{
		GameState->Player |= 2;
		GameState->Second.Status = TRUE;
	}

	return TRUE;
}

DWORD WINAPI ExitProgress(LPVOID pParam)
{
	// NeBJZNV
	EnterCriticalSection(&cs);

	// Vbg̕`I҂
	while( ClientInfo.CDCD->hDrawThread == INVALID_HANDLE_VALUE || ClientInfo.CDCD->bSimulate == TRUE ){ Sleep( 50 ); }
	WaitForSingleObject( ClientInfo.CDCD->hDrawThread, INFINITE );

	// s̑M
	int iScore = 0;
	for (int i = 0; i < GameState->LastEnd; i++){
		iScore += GameState->Score[i];
	}

	if (iScore > 0){
		Send(GameState->First.WritePipe, "GAMEOVER WIN");
		Send(GameState->Second.WritePipe, "GAMEOVER LOSE");
	}
	else if (iScore == 0){
		Send(GameState->First.WritePipe, "GAMEOVER DRAW");
		Send(GameState->Second.WritePipe, "GAMEOVER DRAW");
	}
	else{
		Send(GameState->First.WritePipe, "GAMEOVER LOSE");
		Send(GameState->Second.WritePipe, "GAMEOVER WIN");
	}

	// vlGWI
	DWORD ExitCode;
	GetExitCodeProcess(ClientInfo.CDCD->FirstProcessInfo.hProcess, &ExitCode);
	TerminateProcess(ClientInfo.CDCD->FirstProcessInfo.hProcess, ExitCode);
	GetExitCodeProcess(ClientInfo.CDCD->SecondProcessInfo.hProcess, &ExitCode);
	TerminateProcess(ClientInfo.CDCD->SecondProcessInfo.hProcess, ExitCode);

	ClientInfo.CDCD->LocalMatch = FALSE;

	// j[̕\؂ւ
	MENUITEMINFO MenuItem = {sizeof(MENUITEMINFO)};
	MenuItem.fMask = MIIM_STRING;
	MenuItem.dwTypeData = "VQ[(&S)";
	CMenu *menu = ClientInfo.CDCD->GetMenu();
	CMenu *sub = menu->GetSubMenu(1);
	sub->SetMenuItemInfo(0, &MenuItem, TRUE);

	memcpy(&ClientInfo.CDCD->mGameState, GameState, sizeof(GAMESTATE));

	free(GameState);
	GameState = NULL;

	// NeBJZNV
	LeaveCriticalSection(&cs);

	return TRUE;
}

void SendGameState()
{
	char buffer[1024];

	if(GameState != NULL){
		// POSITIONR}h
		sprintf_s(buffer, sizeof(buffer), "POSITION %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f",
			GameState->body[0][0], GameState->body[0][1],
			GameState->body[1][0], GameState->body[1][1],
			GameState->body[2][0], GameState->body[2][1],
			GameState->body[3][0], GameState->body[3][1],
			GameState->body[4][0], GameState->body[4][1],
			GameState->body[5][0], GameState->body[5][1],
			GameState->body[6][0], GameState->body[6][1],
			GameState->body[7][0], GameState->body[7][1],
			GameState->body[8][0], GameState->body[8][1],
			GameState->body[9][0], GameState->body[9][1],
			GameState->body[10][0], GameState->body[10][1],
			GameState->body[11][0], GameState->body[11][1],
			GameState->body[12][0], GameState->body[12][1],
			GameState->body[13][0], GameState->body[13][1],
			GameState->body[14][0], GameState->body[14][1],
			GameState->body[15][0], GameState->body[15][1]
			);

		Send(GameState->First.WritePipe, buffer);
		Send(GameState->Second.WritePipe, buffer);

		// SETSTATER}h
		sprintf_s(buffer, sizeof(buffer), "SETSTATE %d %d %d %d", GameState->ShotNum, GameState->CurEnd, GameState->LastEnd, GameState->WhiteToMove);
		Send(GameState->First.WritePipe, buffer);
		Send(GameState->Second.WritePipe, buffer);
	}
}

// ۂɉZꂽVbg̕`
void RunShot(SHOTVEC ShotVec)
{
	// `ptO
	ClientInfo.CDCD->hDrawThread = INVALID_HANDLE_VALUE;
	if (ClientInfo.CDCD->mGameState.ShotNum == 0){
		ClientInfo.CDCD->FirstShot = ClientInfo.CDCD->mGameState.WhiteToMove;
	}

	ClientInfo.CDCD->mRand = 0.0f;
	ClientInfo.CDCD->hDrawThread = CreateSimulationThread(ClientInfo.CDCD, ShotVec);
}

// XRȂM
BOOL SendScore(int score)
{
	BOOL bRet = TRUE;
	char buffer[1024];

	sprintf_s(buffer, sizeof(buffer), "SCORE %d", score);
	Send(GameState->First.WritePipe, buffer);
	Send(GameState->Second.WritePipe, buffer);

	return bRet;
}

// Q[is
int SimulateProc(float x, float y, bool turn)
{
	int iRet;
	char buffer[1024];

	SHOTVEC ShotVec, ResShot;
	ShotVec.x = x; ShotVec.y = y; ShotVec.angle = turn;

	GAMESTATE _GameState;
	if(GameState != NULL){
		memcpy(&_GameState, GameState, sizeof(GAMESTATE));
		memcpy(&ClientInfo.CDCD->mGameState, GameState, sizeof(GAMESTATE));
	}
	iRet = Simulation(&_GameState, ShotVec, GameState->Random, &ResShot, -1);
	if(GameState != NULL){
		memcpy(GameState, &_GameState, sizeof(GAMESTATE));
	}

	// Vbg̕`
	RunShot(ResShot);

	// Vbg̕`I҂
	while( ClientInfo.CDCD->hDrawThread == INVALID_HANDLE_VALUE || ClientInfo.CDCD->bSimulate == TRUE ){ Sleep( 50 ); }
	WaitForSingleObject( ClientInfo.CDCD->hDrawThread, INFINITE );

	memcpy(&ClientInfo.CDCD->mGameState, GameState, sizeof(GAMESTATE));
	SetDispNumber(ClientInfo.CDCD);

	// Xg[WƋǖʏ̑M
	SendGameState();

	// 16Iꍇ̏
	//-------------------------------------
	if (GameState->ShotNum == 0){
		// XRȂM
		SendScore(GameState->Score[GameState->CurEnd - 1]);

		// ŏIGh̏ꍇ̏
		//-------------------------------------
		if (GameState->CurEnd >= GameState->LastEnd){
			DWORD dwThreadId;

			LeaveCriticalSection(&cs);
			// I			
			WaitForSingleObject(CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE)ExitProgress, NULL, 0, &dwThreadId), INFINITE);
			EnterCriticalSection(&cs);
			return iRet;
		}
	}

	// GOR}h
	sprintf_s(buffer, sizeof(buffer), "GO %d %d", GameState->First.RemainingTime, GameState->Second.RemainingTime);

	if (GameState->WhiteToMove == 0){
		Send(GameState->First.WritePipe, buffer);
		GameState->First.StartingTime = GetTickCount();
	}
	else{
		Send(GameState->Second.WritePipe, buffer);
		GameState->Second.StartingTime = GetTickCount();
	}

	return iRet;
}

BOOL DoCommand(PLAYERINFO *pPlayer, char *msg)
{
	BOOL bRet = TRUE;
	char buffer[1024];

	// R}h̐؂o
	if (GetArgument(buffer, sizeof(buffer), msg, 0) == false){
		return FALSE;
	}

	// NeBJZNV
	EnterCriticalSection(&cs);
	if(GameState == NULL || ClientInfo.CDCD->LocalMatch == FALSE){
		LeaveCriticalSection(&cs);
		return FALSE;
	}

	// READYOK
	//--------------------------------
	if (pPlayer != NULL && _stricmp(buffer, "READYOK") == 0){
		// Xe[^X̕ύX
		pPlayer->Status = TRUE;

		// Q[X^[g
		if(GameState->First.Status == TRUE && GameState->Second.Status == TRUE){
			Send(GameState->First.WritePipe, "NEWGAME");
			Send(GameState->Second.WritePipe, "NEWGAME");
			SendGameState();

			// GOR}h
			sprintf_s(buffer, sizeof(buffer), "GO %d %d", GameState->First.RemainingTime, GameState->Second.RemainingTime);
			Send(GameState->First.WritePipe, buffer);
			GameState->First.StartingTime = GetTickCount();
		}
	}
	// BESTSHOT
	//--------------------------------
	else if (_stricmp(buffer, "BESTSHOT") == 0){
		float x, y;
		int turn;

		if ((pPlayer == NULL && (GameState->WhiteToMove+1 & GameState->Player)) || GameState->WhiteToMove == pPlayer->Color){
			// Vbg̋()
			if (GetArgument(buffer, sizeof(buffer), msg, 1) == false){
				bRet = FALSE;
			}
			x = (float)atof(buffer);

			// Vbg̋(c)
			if (GetArgument(buffer, sizeof(buffer), msg, 2) == false){
				bRet = FALSE;
			}
			y = (float)atof(buffer);

			// ](0:E]A1:])
			if (GetArgument(buffer, sizeof(buffer), msg, 3) == false){
				bRet = FALSE;
			}
			turn = atoi(buffer);

			if(bRet != FALSE){
				if(pPlayer != NULL){
					// ԌvZ
					pPlayer->RemainingTime -= GetTickCount() - pPlayer->StartingTime;
				}
				else{
					// ShotPos -> ShotVec ϊ
					SHOTPOS ShotPos;
					SHOTVEC ShotVec;
					ShotPos.x = x;
					ShotPos.y = y;
					ShotPos.angle = turn;
					CreateShot(ShotPos, &ShotVec);
					x = ShotVec.x;
					y = ShotVec.y;
					turn = ShotVec.angle;
				}

				SimulateProc(x, y, (bool)turn);
				SendGameState();
			}
		}
	}

	// NeBJZNV
	LeaveCriticalSection(&cs);

	return bRet;
}
